#ifndef __PROTO_H__
#define __PROTO_H__

#include <npconn/netdef.h>

#ifdef HAVE_CONFIG_H
#include <npconn/config.h>
#endif

#define PROT_CONNECT   0
#define PROT_CONNLESS  1
#define PROT_IPRAWSOC  2
#define PROT_MULTICAS  4

struct prot {
  char *name;                                          /* protocol name  */
  int flags;                                           /* protocol flags */
  int(*accept)(netnode, netnode, int flags, netnode *);/* accept()  */
  int(*send)(netnode, netnode, int flags, char *data, int size); /* send()    */
  int(*recv)(netnode, netnode, int flags, char *data, int size); /* recv()    */
  int(*conn)(netnode, netnode, int flags);             /* connect() */
  int(*disc)(netnode, netnode);                        /* close()   */
};

typedef struct prot protocol;

struct linked_prots{
  protocol *p; /* reference of protocol */
  struct linked_prots *link;  /* next entry */
};

extern struct linked_prots builtin; /* for protocols built in */

extern int initialize_npconn();
extern int register_protocol(protocol*);
extern int remove_protocol(char*);

extern protocol *get_protocol(char*);

extern int add_protocol();  /* this is so a protocol can register itself somehow
			       loaded protocols will be invoked with this function */

#endif
