#include <netdef.h>
#include <proto.h>
#include <hash.h>
#include <string.h>

#ifdef DEBUG
#include <util.h>
#endif

struct linked_prots builtin = {NULL, NULL};

struct hash proto_hash;

int protocol_equal(protocol *p1, protocol *p2){
  return strcmp(p1->name,p2->name);
}

int get_prot_hash(protocol *p){
  return get_hash(p->name);
}

int get_hash(char *n){
  int total = 0;

  while(*n != '\0'){ total = total + *n; n++; };

  return total % 128;
}

int proto_eq(int i, void *p, void *c){
  /* return(!strcmp(p->name, c->name)); */
  return 1; /* figure out something */
}

int initialize_npconn(){
  struct linked_prots *prots = &builtin;
  hash_init(&proto_hash, 128, proto_eq); /* figure out kra's stuff */
  
  while(prots->p != NULL){
    register_protocol(prots->p);
    prots = prots->link;
  }
  return 0;
}

int register_protocol(protocol *p){
#ifdef DEBUG
  __util_debug_print("Registering protocol");
#endif
  return hash_put(&proto_hash, get_prot_hash(p), p);
}

int remove_protocol(char *n){
  void *d = NULL;
  d = hash_remove(&proto_hash, get_hash(n), NULL);
  if(d != NULL)
    return -1;
  return 0;
}

protocol *get_protocol(char *n){
#ifdef DEBUG
  protocol *p = NULL;
  char tmp[256];
  __util_debug_print("getting protocol");
  __util_debug_print(n);
  sprintf(tmp, "hash: %d\nprotocol: %s\n", get_hash(n), n);
  __util_debug_print(tmp);
  p = (protocol *)hash_get(&proto_hash, get_hash(n), NULL);
  __util_debug_print("retrieved");
  if(p == NULL){
    __util_debug_print("ERRORS WITH GETTING PROTOCOL\n");
  }
  __util_debug_print("returning - get_protocol()");
  return p;
#endif
  return (protocol *) hash_get(&proto_hash, get_hash(n), NULL);
}


