/**
 * NetPipe Connector Architecture
 * I/O example  -  Serial communication
 * This is released under the GNU LGPL. There are NO GUARANTEES WHATSOEVER
 * ON THIS SOFTWARE. THERE IS NOT EVEN THE IMPLIED GUARANTEE THAT THIS SOFTWARE
 * WILL WORK. IF IT BREAKS YOUR MACHINE, YOU ARE TO BLAME.
 *
 * If you'd like to use this code as a framework, you should look at
 * proto-serial.c for information about any flags, or other options that
 * can be passed to the serial communications protocol.
 */

#include <npconn/netdef.h>
#include <npconn/proto.h>
#include <npconn/conn.h>

#include <stdio.h>
#include <string.h>

#define SERIAL "/dev/ttyS0"

int main(){
  char buf[8192];
  connection *c;
  netnode *n1, *n2;

  init_npconn();

  n1 = (netnode *)malloc(sizeof(netnode));
  n2 = (netnode *)malloc(sizeof(netnode));

  bzero(n2, sizeof(n2));

  n1->host = (char *) malloc (strlen(SERIAL));
  strcpy(n1->host, SERIAL); /* copy the location into n1->host */

  /* default connection: 9600,8,n,1 */
  c = new_connection(*n1, *n2, get_protocol("serial-comm"), 0);

  if(c == NULL){
    free(n1);
    free(n2);
    printf("Error: unallocated connection. Not Enough Memory Available.\n");
    return -1;
  }

  if(connectout(c) < 0){
    free(n1);
    free(n2);
    destroy(c);
    printf("Error: Unable to connect to serial port\n");
    return -1;
  }

  /* connection is live... send and receive */
  do{
    if(poll_conn(c, 10)){
      /* reading?? */
      recvdata(c, buf, 0);
    }
    if(getchar() == 'i'){
      printf("Enter a string: ");
      gets(buf); /* this is terribly insecure, but it's only a sample, and NOT
		    SUID */
      if(!strncmp(buf, "quit", 4)){
	disconnect(c);
	goto end;
      }else
	senddata(c, buf, 0);
    }
  }while(!isdisconnected(c));

 end:

  free(n1);
  free(n2);
  destroy(c);

  return 0;
}
